package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.SysScreeningAssessmentQuestionBo;
import org.dromara.system.domain.vo.SysScreeningAssessmentQuestionVo;
import org.dromara.system.domain.SysScreeningAssessmentQuestion;
import org.dromara.system.mapper.SysScreeningAssessmentQuestionMapper;
import org.dromara.system.service.ISysScreeningAssessmentQuestionService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 题目Service业务层处理
 *
 * @author Lion Li
 * @date 2025-07-08
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class SysScreeningAssessmentQuestionServiceImpl implements ISysScreeningAssessmentQuestionService {

    private final SysScreeningAssessmentQuestionMapper baseMapper;

    /**
     * 查询题目
     *
     * @param questionId 主键
     * @return 题目
     */
    @Override
    public SysScreeningAssessmentQuestionVo queryById(Long questionId){
        return baseMapper.selectVoById(questionId);
    }

    /**
     * 分页查询题目列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 题目分页列表
     */
    @Override
    public TableDataInfo<SysScreeningAssessmentQuestionVo> queryPageList(SysScreeningAssessmentQuestionBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SysScreeningAssessmentQuestion> lqw = buildQueryWrapper(bo);
        Page<SysScreeningAssessmentQuestionVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的题目列表
     *
     * @param bo 查询条件
     * @return 题目列表
     */
    @Override
    public List<SysScreeningAssessmentQuestionVo> queryList(SysScreeningAssessmentQuestionBo bo) {
        LambdaQueryWrapper<SysScreeningAssessmentQuestion> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SysScreeningAssessmentQuestion> buildQueryWrapper(SysScreeningAssessmentQuestionBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SysScreeningAssessmentQuestion> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(SysScreeningAssessmentQuestion::getQuestionId);
        lqw.eq(bo.getConfigId() != null, SysScreeningAssessmentQuestion::getConfigId, bo.getConfigId());
        lqw.eq(StringUtils.isNotBlank(bo.getTitle()), SysScreeningAssessmentQuestion::getTitle, bo.getTitle());
        lqw.eq(StringUtils.isNotBlank(bo.getQuestionType()), SysScreeningAssessmentQuestion::getQuestionType, bo.getQuestionType());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), SysScreeningAssessmentQuestion::getContent, bo.getContent());
        return lqw;
    }

    /**
     * 新增题目
     *
     * @param bo 题目
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(SysScreeningAssessmentQuestionBo bo) {
        SysScreeningAssessmentQuestion add = MapstructUtils.convert(bo, SysScreeningAssessmentQuestion.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setQuestionId(add.getQuestionId());
        }
        return flag;
    }

    /**
     * 修改题目
     *
     * @param bo 题目
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(SysScreeningAssessmentQuestionBo bo) {
        SysScreeningAssessmentQuestion update = MapstructUtils.convert(bo, SysScreeningAssessmentQuestion.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SysScreeningAssessmentQuestion entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除题目信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
